package monnethic.mobile.homepage;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import com.example.monnthic.monnethicmobile.R;

import monnethic.mobile.demoConfig.DemoConfig;

public class HomepageActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_homepage);
        Button bRegister = findViewById(R.id.register);
        Button bLogin = findViewById(R.id.login);
        Button bConfig = findViewById(R.id.buttonConfig);

        bRegister.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                launchRegisterActivity();
            }
        });
        bLogin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                launchLoginActivity();
            }
        });
        bConfig.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                launchConfActivity();
            }
        });
    }

    public void launchRegisterActivity(){
        if(ContextCompat.checkSelfPermission(this,Manifest.permission.INTERNET)!=PackageManager.PERMISSION_GRANTED){
            ActivityCompat.requestPermissions(this,new String[]{Manifest.permission.INTERNET},1);
        }
        Intent registerIntent = new Intent(HomepageActivity.this, RegisterActivity.class);
        HomepageActivity.this.startActivity(registerIntent);
    }

    public void launchLoginActivity(){
        if(ContextCompat.checkSelfPermission(this,Manifest.permission.INTERNET)!=PackageManager.PERMISSION_GRANTED){
            ActivityCompat.requestPermissions(this,new String[]{Manifest.permission.INTERNET},1);
        }
        Intent loginIntent = new Intent(HomepageActivity.this, LoginActivity.class);
        HomepageActivity.this.startActivity(loginIntent);
    }

    public void launchConfActivity(){
        Intent confIntent = new Intent(HomepageActivity.this, DemoConfig.class);
        HomepageActivity.this.startActivity(confIntent);
    }

}
