package monnethic.mobile.homepage;

import android.os.AsyncTask;
import android.widget.EditText;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import monnethic.mobile.restApi.UserApiHandler;

public class InputController {
    private static Pattern pattern;
    private static Matcher matcher;
    private static final String PASSWORD_PATTERN = "((?=.*\\d)(?=.*[a-z])(?=.*[A-Z]).{6,20})";

    public static boolean isEmptyEdit(EditText etText) {
        return etText.getText().toString().trim().length() == 0;
    }
    public static boolean validEmail(String email){
        return android.util.Patterns.EMAIL_ADDRESS.matcher(email).matches();
    }
    public static boolean passwordValidator(String password){
        pattern = Pattern.compile(PASSWORD_PATTERN);
        matcher = pattern.matcher(password);
        return matcher.matches();
    }


    public static Boolean checkUser(String email){
        Boolean result = null;
        try{
            String[] params = new String[]{email};
            result = new CheckUserTask().execute(params).get();
        } catch (Exception e){
            e.printStackTrace();
        }
        return result;
    }

    private static class CheckUserTask extends AsyncTask<String,String,Boolean> {

        @Override
        protected Boolean doInBackground(String... params) {
            UserApiHandler userApiHandler = new UserApiHandler();
            return userApiHandler.checkUser(params[0]);
        }
    }
}
