package monnethic.mobile.restApi;

import org.json.JSONObject;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

public class ConfigApiHandler {
    public void updateEnvironment(String environment){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            String url = Config.CONFIG_ENVIRONMENT;
            Map<String, String> map = new HashMap<>();
            map.put("env",environment);
            httpCallHandler.postHttp(new URL(url), map);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    public void updateChaincode(String chaincode){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            String url = Config.CONFIG_CHAINCODE;
            Map<String, String> map = new HashMap<>();
            map.put("chaincode",chaincode);
            httpCallHandler.postHttp(new URL(url), map);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    public String getConfiguration(){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        String result="";
        try{
            String chaincode = new JSONObject(httpCallHandler.getHttp(new URL(Config.CONFIG_CHAINCODE))).getString("chaincode");
            String environment = new JSONObject(httpCallHandler.getHttp(new URL(Config.CONFIG_ENVIRONMENT))).getString("env");
            String db = new JSONObject(httpCallHandler.getHttp(new URL(Config.CONFIG_DB))).getString("db");
            result = environment+" - "+chaincode+" - "+db;
        }catch (Exception e){
            e.printStackTrace();
        }
        return result;
    }

}
