package monnethic.mobile.restApi;

import org.json.JSONObject;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.Charset;
import java.util.Map;

public class HttpCallHandler {

    public String getHttp(URL url) throws Exception {
        InputStream inputStream;
        BufferedReader bufferedReader = null;
        HttpURLConnection urlConnection = null;

        urlConnection = (HttpURLConnection) url.openConnection();
        urlConnection.setRequestMethod("GET");
        urlConnection.connect();

        int responseCode = urlConnection.getResponseCode();
        if(responseCode != 200){
            throw new Exception("ERROR != 200");
        }
        inputStream = urlConnection.getInputStream();
        if(inputStream == null){
            throw new Exception("ERROR inputStream");
        }

        bufferedReader = new BufferedReader(new InputStreamReader(urlConnection.getInputStream()));
        StringBuilder stringBuilder = new StringBuilder();
        String line;

        while ((line = bufferedReader.readLine())!=null){
            stringBuilder.append(line);
        }

        return stringBuilder.toString();
    }




    public String postHttp(URL url, Map<String,String> params) throws Exception {
        String returnValue=null;
        HttpURLConnection urlConnection = null;
        urlConnection = (HttpURLConnection) url.openConnection();
        urlConnection.setRequestMethod("POST");
        urlConnection.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
        urlConnection.setRequestProperty("Accept","application/json");
        urlConnection.setDoOutput(true);
        urlConnection.setDoInput(true);

        JSONObject jsonParam = new JSONObject();
        for(Map.Entry<String,String> pair : params.entrySet()){
            jsonParam.put(pair.getKey(),pair.getValue());
        }

        DataOutputStream os = new DataOutputStream(urlConnection.getOutputStream());
        os.write(jsonParam.toString().getBytes("UTF-8"));

        int statusCode = urlConnection.getResponseCode();
        if(statusCode != 200){
            JSONObject jsonReturn = new JSONObject();
            if(statusCode == 404){
                jsonReturn.put("status",404);
                jsonReturn.put("response","Not Found");
                returnValue = jsonReturn.toString();
            }else if(statusCode == 403){
                jsonReturn.put("status",403);
                jsonReturn.put("response","Forbidden");
                returnValue = jsonReturn.toString();
            }
        } else {
            BufferedReader bufferedReader = null;
            bufferedReader = new BufferedReader(new InputStreamReader(urlConnection.getInputStream()));
            StringBuilder stringBuilder = new StringBuilder();

            String line;
            while ((line = bufferedReader.readLine())!=null){
                stringBuilder.append(line);
            }

            JSONObject json = new JSONObject(stringBuilder.toString());
            json.put("status",200);
            returnValue = json.toString();
        }
        return returnValue;
    }

    public void postHttpSession(URL url, Map<String,Integer> params) throws Exception {
        HttpURLConnection urlConnection = null;
        urlConnection = (HttpURLConnection) url.openConnection();
        urlConnection.setRequestMethod("POST");
        urlConnection.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
        urlConnection.setRequestProperty("Accept","application/json");
        urlConnection.setDoOutput(true);
        urlConnection.setDoInput(true);

        JSONObject jsonParam = new JSONObject();
        for(Map.Entry<String,Integer> pair : params.entrySet()){
            jsonParam.put(pair.getKey(),pair.getValue());
        }

        DataOutputStream os = new DataOutputStream(urlConnection.getOutputStream());
        os.write(jsonParam.toString().getBytes("UTF-8"));
        urlConnection.getResponseCode();
    }
}
