package monnethic.mobile.restApi;

import org.json.JSONArray;
import org.json.JSONObject;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import monnethic.mobile.database.Transaction;
import monnethic.mobile.transaction.SendingTransaction;

public class TransactionApiHandler {

    public String doTransaction(SendingTransaction sendingTransaction){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            String url = Config.TRANSACTION_SEND;
            Map<String,String> map = new HashMap<>();
            map.put("source_user_hash",sendingTransaction.getSource_user_hash());
            map.put("source_user_pwd",sendingTransaction.getSource_user_pwd());
            map.put("transaction_from",sendingTransaction.getTransaction_from());
            map.put("transaction_to",sendingTransaction.getTransaction_to());
            map.put("transaction_amount",sendingTransaction.getTransaction_amount());
            map.put("transaction_unit",sendingTransaction.getTransaction_unit());
            String response = httpCallHandler.postHttp(new URL(url),map);
            JSONObject jsonObject = new JSONObject(response);
            return jsonObject.getString("response");
        }catch (Exception e){
            e.printStackTrace();
        }
        return "";
    }

    public ArrayList<Transaction> getTransactions(String function, String url, String wallet_hash,
                                                  String size, String start_date, String end_date){
        ArrayList<Transaction> transactionsList = new ArrayList<>();
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            if(Integer.parseInt(function)==0){
                url = url+"?wallet_hash="+wallet_hash;
            } else if(Integer.parseInt(function)==1 || Integer.parseInt(function)==2 || Integer.parseInt(function)==3){
                url = url+"?size="+size+"&wallet_hash="+wallet_hash;
            } else {
                url = url+"?size="+size+"&wallet_hash="+wallet_hash+"&start_date="+start_date+"&end_date="+end_date;
            }

            String response = httpCallHandler.getHttp(new URL(url));
            JSONArray jsonArray = new JSONArray(response);

            for(int i=0; i<jsonArray.length(); i++){
                Transaction transaction = new Transaction();
                JSONObject jsonObject = jsonArray.getJSONObject(i);

                transaction.setTransactionDate(Long.parseLong(jsonObject.getString("transaction_date")));
                transaction.setTransactionFrom(jsonObject.getString("transaction_from"));
                transaction.setTransactionTo(jsonObject.getString("transaction_to"));
                transaction.setTransactionHash(jsonObject.getString("transaction_hash"));
                transaction.setTransactionAmount(jsonObject.getDouble("transaction_amount"));
                transaction.setTransactionUnit(jsonObject.getString("transaction_unit"));

                transactionsList.add(transaction);
            }

        }catch (Exception e){
            e.printStackTrace();
        }
        return transactionsList;
    }
}
