package monnethic.mobile.restApi;

import org.json.JSONArray;
import org.json.JSONObject;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import monnethic.mobile.wallet.Wallet;

public class WalletApiHandler {

    public ArrayList<Wallet> getUserWallets(String[] params){
        ArrayList<Wallet> walletList = new ArrayList<>();
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try {
            String url = Config.WALLET_GET_USER_WALLETS+"?user_hash="+params[0];
            String responseCall = httpCallHandler.getHttp(new URL(url));
            JSONArray jsonArray = new JSONArray(responseCall);

            for(int i=0; i<jsonArray.length(); i++){
                Wallet wallet = new Wallet();
                JSONObject jsonObject = jsonArray.getJSONObject(i);

                wallet.setType(jsonObject.getJSONObject("Record").getJSONObject("walletType").getString("string"));
                wallet.setWallet_hash(jsonObject.getJSONObject("Record").getJSONObject("id").getString("string"));
                wallet.setUser_hash(jsonObject.getJSONObject("Record").getJSONObject("owner").getString("string"));

                String urlGetWallet = Config.WALLET_GET_WALLET+"?wallet_hash="+wallet.getWallet_hash();
                String responseWallet = httpCallHandler.getHttp(new URL(urlGetWallet));
                JSONObject jsonWallet = new JSONObject(responseWallet);

                wallet.setBalance(jsonWallet.getDouble("balance"));
                walletList.add(wallet);
            }
        } catch (Exception e){
            e.printStackTrace();
        }
        return walletList;
    }

    public Double getWalletBalance(String [] params){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            String url = Config.WALLET_GET_WALLET+"?wallet_hash="+params[0];
            String responseCall = httpCallHandler.getHttp(new URL(url));
            JSONObject jsonObject = new JSONObject(responseCall);
            return jsonObject.getDouble("balance");
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public Wallet createWallet(Wallet wallet){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try {
            String url = Config.WALLET_CREATE;
            Map<String, String> map = new HashMap<>();

            map.put("user_hash",wallet.getUser_hash());
            map.put("type",wallet.getType());
            String responseCall = httpCallHandler.postHttp(new URL(url), map);

            JSONObject jsonObject = new JSONObject(responseCall);
            wallet.setWallet_hash(jsonObject.getString("wallet_hash"));
            wallet.setBalance(jsonObject.getDouble("balance"));

            return wallet;
        } catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }
}
