package monnethic.mobile.search;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import com.example.monnthic.monnethicmobile.R;
import java.util.ArrayList;
import monnethic.mobile.restApi.SessionApiHandler;
import monnethic.mobile.restApi.WalletApiHandler;
import monnethic.mobile.wallet.Wallet;

public class DisplayWalletSearch extends AppCompatActivity {
    private ArrayList<Wallet> userWallets;
    private String session_id;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_display_wallet_search);

        ListView listView = (ListView) findViewById(R.id.listViewWalletSearch);
        Intent intent = getIntent();
        String user_name = intent.getStringExtra("user_name");
        String user_firstname = intent.getStringExtra("user_firstname");
        String user_hash = intent.getStringExtra("user_hash");
        session_id = intent.getStringExtra("SESSION_ID");

        try {
            userWallets = new SearchWalletTask().execute(user_hash).get();
        } catch (Exception e){
            e.printStackTrace();
        }

        ArrayList<DisplayWallet> displayWallets = new ArrayList<>();
        for(Wallet w : userWallets){
            displayWallets.add(new DisplayWallet(user_name,user_firstname,w.getWallet_hash()));
        }
        DisplayWalletAdapter adapter = new DisplayWalletAdapter(this,displayWallets);
        listView.setAdapter(adapter);

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                DisplayWallet dW = (DisplayWallet) listView.getItemAtPosition(i);
                Intent intent1 = new Intent();
                intent1.putExtra("walletHash",dW.getWallet_hash());
                setResult(1,intent1);
                finish();
            }
        });
    }


    private class SearchWalletTask extends AsyncTask<String,String,ArrayList<Wallet>> {
        ProgressDialog progDailog = new ProgressDialog(DisplayWalletSearch.this);

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            progDailog.setMessage("Searching user wallets...");
            progDailog.setIndeterminate(false);
            progDailog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progDailog.setCancelable(true);
            progDailog.show();
        }

        @Override
        protected void onPostExecute(ArrayList<Wallet> listWallet) {
            progDailog.dismiss();
        }

        @Override
        protected ArrayList<Wallet> doInBackground(String... strings) {
            ArrayList<Wallet> walletsList = new ArrayList<>();
            try{
                WalletApiHandler walletApiHandler = new WalletApiHandler();
                walletsList = walletApiHandler.getUserWallets(strings);
            }catch (Exception e){
                e.printStackTrace();
            }
            return walletsList;
        }
    }

    @Override
    protected void onStop() {
        super.onStop();  // Always call the superclass method first
        new EndSessionTask().execute(session_id);
    }

    private class EndSessionTask extends AsyncTask<String,Void,Void> {
        @Override
        protected Void doInBackground(String... strings) {
            try{
                SessionApiHandler sessionApiHandler = new SessionApiHandler();
                sessionApiHandler.endSession(strings[0]);
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }
    }

}
