package monnethic.mobile.transaction;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.example.monnthic.monnethicmobile.R;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Locale;

import monnethic.mobile.database.Transaction;

public class TransactionAdapter extends ArrayAdapter<Transaction> {
    private String wallet_hash;

    public TransactionAdapter(Context context, ArrayList<Transaction> transactions, String wallet_hash){
        super(context,0,transactions);
        this.wallet_hash = wallet_hash;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent){
        Transaction transaction = getItem(position);

        if(convertView == null){
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.transaction_view_template, parent, false);
        }

        TextView txID = convertView.findViewById(R.id.displayTxId);
        TextView date = convertView.findViewById(R.id.displayTxDate);
        TextView type = convertView.findViewById(R.id.displayTxType);
        TextView amount = convertView.findViewById(R.id.displayTxAmount);


        ViewGroup.LayoutParams params = convertView.getLayoutParams();
        params.height = 250;
        convertView.setLayoutParams(params);

        String myFormat = "dd-MM-yyyy HH:mm:ss";
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.FRANCE);
        Date dateTransaction = new Date(transaction.getTransactionDate());

        String typeOfTransaction;
        if(transaction.getTransactionFrom().equals(wallet_hash)){
            typeOfTransaction="Sent";
        }else{
            typeOfTransaction="Received";
        }

        txID.setText(transaction.getTransactionHash());
        date.setText(sdf.format(dateTransaction));
        type.setText(typeOfTransaction);
        amount.setText(String.valueOf(transaction.getTransactionAmount()));

        return convertView;
    }

}
