package monnethic.mobile.wallet;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import com.example.monnthic.monnethicmobile.R;

import monnethic.mobile.restApi.SessionApiHandler;
import monnethic.mobile.restApi.WalletApiHandler;
import monnethic.mobile.user.UserAccountActivity;

public class CreateWalletActivity extends AppCompatActivity {
    private String user_hash;
    private String user_password;
    private String session_id;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_create_wallet);

        EditText wallet_type = findViewById(R.id.editTextWalletType);
        Button buttonValidate = findViewById(R.id.buttonValidate);
        Button buttonCancel = findViewById(R.id.buttonCancel);

        Context context = this;
        Intent intent = getIntent();
        user_hash = intent.getStringExtra("USER_HASH");
        user_password = intent.getStringExtra("USER_PWD");
        session_id = intent.getStringExtra("SESSION_ID");

        buttonValidate.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //TODO ASYNC wallet_type
                Wallet wallet = new Wallet(wallet_type.getText().toString(),user_hash);
                new CreateWalletTask(context).execute(wallet);
            }
        });

        buttonCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });

    }

    private class CreateWalletTask extends AsyncTask<Wallet,String,Wallet> {
        Context mContext;
        private CreateWalletTask(final Context context){
            mContext = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            ProgressDialog progDailog = new ProgressDialog(CreateWalletActivity.this);
            progDailog.setMessage("Creating...");
            progDailog.setIndeterminate(false);
            progDailog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progDailog.setCancelable(true);
            progDailog.show();
        }

        @Override
        protected void onPostExecute(Wallet w) {
            try{
                Intent accountIntent = new Intent(CreateWalletActivity.this, UserAccountActivity.class);
                accountIntent.putExtra("USER_HASH", user_hash);
                accountIntent.putExtra("USER_PWD",user_password);
                accountIntent.putExtra("SESSION_ID",session_id);
                accountIntent.putExtra("WALLET_HASH",w.getWallet_hash());
                accountIntent.putExtra("WALLET_BALANCE",String.valueOf(w.getBalance()));
                accountIntent.putExtra("WALLET_TYPE",w.getType());
                CreateWalletActivity.this.startActivity(accountIntent);
                finish();
            }catch (Exception e){
                e.printStackTrace();
            }
        }

        @Override
        protected Wallet doInBackground(Wallet... w) {
            try{
                WalletApiHandler walletApiHandler = new WalletApiHandler();
                return walletApiHandler.createWallet(w[0]);
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }
    }

    @Override
    protected void onStop() {
        super.onStop();  // Always call the superclass method first
        new EndSessionTask().execute(session_id);
    }

    private class EndSessionTask extends AsyncTask<String,Void,Void> {
        @Override
        protected Void doInBackground(String... strings) {
            try{
                SessionApiHandler sessionApiHandler = new SessionApiHandler();
                sessionApiHandler.endSession(strings[0]);
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }
    }
}
