package monnethic.mobile.wallet;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import com.example.monnthic.monnethicmobile.R;
import java.util.ArrayList;
import monnethic.mobile.restApi.SessionApiHandler;
import monnethic.mobile.restApi.WalletApiHandler;
import monnethic.mobile.user.UserAccountActivity;

public class SelectWalletActivity extends AppCompatActivity {
    private ArrayList<Wallet> userWallets;
    private String user_hash;
    private String user_password;
    private String session_id;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_select_wallet);

        ListView listView = (ListView) findViewById(R.id.listViewWallet);
        Intent intent = getIntent();
        user_hash = intent.getStringExtra("USER_HASH");
        user_password = intent.getStringExtra("USER_PWD");
        session_id = intent.getStringExtra("SESSION_ID");
        String[] params = {user_hash};

        try {
            userWallets = new getUserWalletTask().execute(params).get();
        } catch (Exception e){
            e.printStackTrace();
        }

        WalletAdapter adapter = new WalletAdapter(this,userWallets);
        listView.setAdapter(adapter);

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                Wallet w = (Wallet) listView.getItemAtPosition(i);
                launchAcountActivity(w);
            }
        });
    }

    public void launchAcountActivity(Wallet w) {
        Intent accountIntent = new Intent(SelectWalletActivity.this, UserAccountActivity.class);
        accountIntent.putExtra("USER_HASH",user_hash);
        accountIntent.putExtra("USER_PWD",user_password);
        accountIntent.putExtra("SESSION_ID",session_id);
        accountIntent.putExtra("WALLET_HASH",w.getWallet_hash());
        accountIntent.putExtra("WALLET_BALANCE",String.valueOf(w.getBalance()));
        accountIntent.putExtra("WALLET_TYPE",w.getType());
        SelectWalletActivity.this.startActivity(accountIntent);
    }

    //AsyncTask to get user wallets
    private class getUserWalletTask extends AsyncTask<String,ArrayList<Wallet>,ArrayList<Wallet>> {
        ProgressDialog progDailog = new ProgressDialog(SelectWalletActivity.this);
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            progDailog.setMessage("Searching...");
            progDailog.setIndeterminate(false);
            progDailog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progDailog.setCancelable(true);
            progDailog.show();
        }

        @Override
        protected ArrayList<Wallet> doInBackground(String... params) {
            ArrayList<Wallet> walletsList = new ArrayList<>();
            try{
                WalletApiHandler walletApiHandler = new WalletApiHandler();
                walletsList = walletApiHandler.getUserWallets(params);
            }catch (Exception e){
                e.printStackTrace();
            }
            return walletsList;
        }

        @Override
        protected void onPostExecute(ArrayList<Wallet> listWallet) {
            progDailog.dismiss();
        }
    }

    @Override
    protected void onStop() {
        super.onStop();  // Always call the superclass method first
        new EndSessionTask().execute(session_id);
    }

    private class EndSessionTask extends AsyncTask<String,Void,Void> {
        @Override
        protected Void doInBackground(String... strings) {
            try{
                SessionApiHandler sessionApiHandler = new SessionApiHandler();
                sessionApiHandler.endSession(strings[0]);
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }
    }
}
