package monnethic.mobile.wallet;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import com.example.monnthic.monnethicmobile.R;
import java.util.ArrayList;

public class WalletAdapter extends ArrayAdapter<Wallet> {
    public WalletAdapter(Context context, ArrayList<Wallet> wallets){
        super(context,0,wallets);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent){
        Wallet wallet = getItem(position);

        if(convertView == null){
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.wallet_view_template, parent, false);
        }

        TextView wallet_hash = convertView.findViewById(R.id.wallet_hash);
        TextView wallet_type = convertView.findViewById(R.id.wallet_type);
        TextView wallet_balance = convertView.findViewById(R.id.wallet_balance);

        ViewGroup.LayoutParams params = convertView.getLayoutParams();
        params.height = 270;
        convertView.setLayoutParams(params);

        wallet_hash.setText(wallet.getWallet_hash());
        wallet_type.setText(wallet.getType());
        wallet_balance.setText(String.valueOf(wallet.getBalance()));

        return convertView;
    }
}
